<!DOCTYPE html>
<html>

<head>
    <script type="text/javascript" src="../../js/jquery-1.11.2.min.js"></script>
    <script type="text/javascript" src="../../libraries/three_js/three.min.js"></script>
    <script type="text/javascript" src="../../libraries/physijs/physi.js"></script>
    <script type="text/javascript" src="../../libraries/three_js/OrbitControls.js"></script>

    <script type="text/javascript">

    'use strict';

    Physijs.scripts.worker = '../../libraries/physijs/physijs_worker.js';
    Physijs.scripts.ammo = '../../libraries/physijs/js/ammo.js';

    var camera, renderer, controls;
    var scene, plane;
    //camera settings
    var WIDTH = 1200, HEIGHT=600;
    var VIEW_ANGLE = 45,
    ASPECT = WIDTH / HEIGHT,
    NEAR = 0.1,
    FAR = 10000;

    $(document).ready(function(){
        init();
    });


    function init(){
        var viewPort =  $('#viewport');
        setUpScene();
        setUpPlane();
        setUpCamera(VIEW_ANGLE,ASPECT,NEAR,FAR);
        setUpRenderer(viewPort);
        setUpLights();
        addToScene();
       // setUpOrbitalControl();

        var box = new Physijs.BoxMesh(
            new THREE.BoxGeometry( 5, 5, 5 ),
            Physijs.createMaterial( // Physijs material
              new THREE.MeshLambertMaterial({ // Three.js material
                color: new THREE.Color("#FFBF00")
              }),
              .9, // friction
              .8 // restitution
            )
        );
        box.position.y= 20;
        

         var box2 = new Physijs.BoxMesh(
            new THREE.BoxGeometry( 5, 5, 5 ),
            Physijs.createMaterial( // Physijs material
              new THREE.MeshLambertMaterial({ // Three.js material
                color: new THREE.Color("#DF0101")
              }),
              .4, // friction
              .8 // restitution
            )
        );
         box2.position.y =40;
         scene.add(box);
         scene.add(box2);
        render();
        //animate();
        //requestAnimationFrame( render );
    }

    function animate(){
        requestAnimationFrame(animate);
        controls.update();
    }

    function render() {
        scene.simulate(); // run physics
        renderer.render( scene, camera); // render the scene
        requestAnimationFrame( render );
    }

    function addToScene(){
        scene.add(camera);
        scene.add(plane);
    }

    function setUpRenderer(viewPort){
        renderer = new THREE.WebGLRenderer();
        renderer.setSize(WIDTH,HEIGHT);
        viewPort.append(renderer.domElement);
    }

    function setUpCamera(angle, aspect, near, far){
        //camera = new THREE.PerspectiveCamera(angle, aspect, near, far);
        //camera.position.set(70, 40, 70);
        //camera.lookAt(scene.position)
        camera = new THREE.PerspectiveCamera( 60, window.innerWidth / window.innerHeight, 1, 1000 );
        camera.position.z = 100;
        camera.position.y=50;
        camera.lookAt(plane.position);
    }

    function setUpLights(){
        var directionalLight = new THREE.DirectionalLight( 0xffffff, 1 );
        directionalLight.position.set(20, 40, -15);
        directionalLight.castShadow =  true;
        directionalLight.shadowCamera = new THREE.OrthographicCamera(60, -60, 60, -60, 20, 200);
        directionalLight.shadowDarkness = 0.7;
        directionalLight.shadowBias = .002;
        scene.add(directionalLight);
        var ambientLight = new THREE.AmbientLight( 0x222222 );
        scene.add(ambientLight);
    }

    function setUpScene(){
        scene = new Physijs.Scene(); // create Physijs scene
        scene.setGravity(new THREE.Vector3( 0, -50, 0 )); // set gravity
        scene.addEventListener('update', function() {
            scene.simulate(); // simulate on every scene update
        });     
    }

    function setUpPlane(){
        plane = new Physijs.BoxMesh( // Physijs mesh
          new THREE.BoxGeometry(100, 2, 100), // Three.js geometry
            Physijs.createMaterial( // Physijs material
              new THREE.MeshLambertMaterial({ // Three.js material
                color: new THREE.Color("#006400")
              }),
              .4, // friction
              .8 // restitution
            ),
            0 // weight, 0 is for zero gravity
        );
        plane.position.x=0;
        plane.position.y=0;
        plane.position.z=0;
    }

    function setUpOrbitalControl(){
        controls = new THREE.OrbitControls( camera );
        controls.damping = 0.2;
        controls.addEventListener( 'change', render );
    }
   

    </script>
</head>

<body>
    <div id="viewport"></div>
</body>
</html>